#ifndef OBJECT_H
#define OBJECT_H

//short int test_map_colision(struct player_struct *playerObj, const short int incx, const short int incy);


void show_object_sprites(SDL_Surface *screen, struct struct_object *obj) {
	// checks if the Object is near the screen to show it
	//printf("********* check draw object, x: %d, y: %d\n", obj->position.x, obj->position.y);
	if (obj->type == OBJ_DISAPPEARING_BLOCK && obj->direction == ANIM_RIGHT) {
		//printf("********* show_object_sprites - hidden object\n");
		return;
	}


	if (obj->position.x+16 >= abs(map_pos_x) && obj->position.x-16 <= abs(map_pos_x)+RES_W) {
		//printf("********* show_object_sprites - MUST DRAW\n");
		SDL_Rect src, dest;

		// animation
		//printf(">> show_object_sprites - sprite.w: %d, frame.w: %d <<\n", obj->sprite->w, obj->framesize_w);
		if (obj->framesize_w * 2 >= obj->sprite->w)  {
			if (obj->frame <= 0 || obj->frame > (obj->sprite->w/obj->framesize_w)-1) {
				obj->frame = 0;
			}
			src.x = obj->frame * TILE_SIZE;
			if (obj->timer < getTimer()) {
				obj->frame++;
				obj->timer = getTimer()+400;
			}
		} else {
			src.x = 0;
		}
		src.y = 0;
		src.w = obj->framesize_w;
		src.h = obj->framesize_h;
		// parte que vai ser colada
		dest.x = obj->position.x + map_pos_x;
		dest.y = obj->position.y + map_pos_y;
		//printf(">>> show_object_sprites - dest.x: %d, dest.y: %d\n", dest.x, dest.y);
		dest.w = obj->framesize_w;
		dest.h = obj->framesize_h;
		//printf("*** 2 - show_object_sprites - dest.x: %d, dest.y: %d, dest.w: %d, dest.h: %d\n", dest.x, dest.y, dest.w, dest.h);
		SDL_BlitSurface(obj->sprite, &src, screen, &dest);
	}
}


// check colision of Player with Objects
// returns 1 for x block, 2 for y block, 3 for x AND y block and 0 for non-blocking items
short int colision_player_object(struct player_struct *playerObj, const short int x_inc, const short int y_inc) {
	struct pos p1, p2, p3, p4;
	struct pos obj1, obj2, obj3, obj4;
	short int passX=0, passY=0;
	int blocked = 0;


	short int reduce = abs(16-playerObj->sprite->w)*0.5;

	// ponto 3, topo/esquerda
	p1.x = playerObj->sprite->x + reduce;
	p1.y = playerObj->sprite->y;

	//printf(">> colision_player_object, p1.x: %d, p1.y: %d, x_inc: %d, y_inc: %d\n", p1.x, p1.y, x_inc, y_inc);


	// ponto 2, baixo/esquerda
	p2.x = playerObj->sprite->x + reduce;
	p2.y = playerObj->sprite->y + 31;

	// ponto 3, topo/direita
	p3.x = playerObj->sprite->x + playerObj->sprite->w - reduce;
	p3.y = playerObj->sprite->y;

	// ponto 4, baixo/direita
	p4.x = playerObj->sprite->x + playerObj->sprite->w - reduce;
	p4.y = playerObj->sprite->y + 31;

	// fix for ground checking
	p1.y = p1.y - 1;
	p2.y = p2.y - 1;
	p3.y = p3.y - 1;
	p4.y = p4.y - 1;


	struct struct_object *temp_obj_list = obj_list;
	while (temp_obj_list) {

		if (temp_obj_list->type != -1 && strstr(temp_obj_list->filename, ".png") != NULL && (temp_obj_list->type != OBJ_DISAPPEARING_BLOCK || temp_obj_list->direction != ANIM_RIGHT)) {
			//printf("*** colision_player_object - obj[%d] is good\n", i);
			obj1.x = temp_obj_list->position.x;
			obj1.y = temp_obj_list->position.y;
			obj2.x = temp_obj_list->position.x;
			obj2.y = temp_obj_list->position.y + temp_obj_list->framesize_h;
			obj3.x = temp_obj_list->position.x + temp_obj_list->framesize_w;
			obj3.y = temp_obj_list->position.y;
			obj4.x = temp_obj_list->position.x + temp_obj_list->framesize_w;
			obj4.y = temp_obj_list->position.y + temp_obj_list->framesize_h;


			//printf("*** colision_player_object - testing obj[%d], p1.y: %d, obj1.y: %d\n", i, p1.y, obj1.y);

			// any point inside NPC is a hit
			passY = 0;
			passX = 0;

			// check if player is on the X range of object
			if (playerObj->sprite->w > temp_obj_list->framesize_w) {
				if ((obj1.x >= p1.x && obj1.x <= p3.x) || (obj3.x >= p1.x && obj3.x <= p3.x)) {
					passX = 1;
				}
			} else {
				if ((p1.x >= obj1.x && p1.x <= obj3.x) || (p3.x >= obj1.x && p3.x <= obj3.x)) {
					passX = 1;
				}
			}

			// check if player is on the Y range of object
			if (playerObj->sprite->h > temp_obj_list->framesize_h) {
				if ((obj1.y >= p1.y && obj1.y <= p2.y) || (obj2.y >= p1.y && obj2.y <= p2.y)) {
					passY = 1;
				}
			} else {
				if ((p1.y >= obj1.y && p1.y <= obj2.y) || (p2.y >= obj1.y && p2.y <= obj3.y)) {
					passY = 1;
				}
			}

			// player is on the left of the object, and moving to right
			if (passY && p1.x >= obj4.x && p1.x+x_inc <= obj4.x) {
				//printf("block X1\n");
				blocked = 1;
			}

			// player is on the right of the object, and moving to left
			if (passY && p3.x <= obj1.x && p3.x+1 >= obj1.x) {
				//printf(">> block X2\n");
				blocked = 1;
			}

			// player is under the object and moving to top
			if (passX && p1.y >= obj4.y && p1.y+y_inc <= obj4.y) {
				if (blocked == 0) {
					blocked = 2;
				} else {
					blocked = 3;
				}
			}
			// player is over the object and moving to bottom
			if (passX && p4.y <= obj1.y && p4.y+y_inc >= obj1.y) {
				if (blocked == 0) {
					blocked = 2;
				} else {
					blocked = 3;
				}
			}

			if (temp_obj_list->type == OBJ_MOVING_PLATFORM_UPDOWN || temp_obj_list->type == OBJ_MOVING_PLATFORM_LEFTRIGHT || temp_obj_list->type == OBJ_DISAPPEARING_BLOCK  || temp_obj_list->type == OBJ_FALL_PLATFORM) {
				if ((blocked == 2 || blocked == 3) && p4.y <= obj1.y) {
					playerObj->platform = temp_obj_list;
					if (temp_obj_list->type == OBJ_FALL_PLATFORM) {
						temp_obj_list->direction = ANIM_DOWN;
					}
				} else if (blocked == 1) {
					playerObj->platform = temp_obj_list;
				}
				if (blocked != 0) {
					return blocked;
				}
			} else if (blocked != 0) {
				if (temp_obj_list->type == OBJ_ENERGY_PILL_SMALL) {
					if (playerObj->HP + 3 <= playerObj->HP_MAX) {
						playerObj->HP += 3;
					} else {
						playerObj->HP = playerObj->HP_MAX;
					}
					play_sfx(SFX_GOT_ENERGY);
				} else if (temp_obj_list->type == OBJ_ENERGY_PILL_BIG) {
					if (playerObj->HP + 8 <= playerObj->HP_MAX) {
						playerObj->HP += 8;
					} else {
						playerObj->HP = playerObj->HP_MAX;
					}
					play_sfx(SFX_GOT_ENERGY);
					play_sfx(SFX_GOT_ENERGY);
				} else if (temp_obj_list->type == OBJ_WEAPON_PILL_SMALL && playerObj->selected_weapon != -1) {
					if (playerObj->items.weapons[playerObj->selected_weapon] + 3 <= playerObj->HP_MAX) {
						playerObj->items.weapons[playerObj->selected_weapon] += 3;
					} else {
						playerObj->items.weapons[playerObj->selected_weapon] = playerObj->HP_MAX;
					}
					play_sfx(SFX_GOT_ENERGY);
				} else if (temp_obj_list->type == OBJ_WEAPON_PILL_BIG && playerObj->selected_weapon != -1) {
					if (playerObj->items.weapons[playerObj->selected_weapon] + 8 <= playerObj->HP_MAX) {
						playerObj->items.weapons[playerObj->selected_weapon] += 8;
					} else {
						playerObj->items.weapons[playerObj->selected_weapon] = playerObj->HP_MAX;
					}
					play_sfx(SFX_GOT_ENERGY);
					play_sfx(SFX_GOT_ENERGY);
				} else if (temp_obj_list->type == OBJ_ENERGY_TANK) {
					playerObj->items.energy_tanks++;
					play_sfx(SFX_GOT_ITEM);
				} else if (temp_obj_list->type == OBJ_WEAPON_TANK) {
					playerObj->items.weapon_tanks++;
					play_sfx(SFX_GOT_ITEM);
				} else if (temp_obj_list->type == OBJ_LIFE) {
					playerObj->items.lifes++;
					play_sfx(SFX_GOT_ITEM);
				}

				temp_obj_list->type = -1;
				SDL_FreeSurface(temp_obj_list->sprite);
				temp_obj_list->sprite = NULL;
				return 0;
			}
		}

		temp_obj_list = temp_obj_list->next;
	}
	if (blocked == 0 && playerObj->platform != NULL) {
		printf("colision_player_object: got out of platform\n");
		playerObj->platform = NULL;
	}
	return blocked;
}

// TODO - adicionar suporte a p2
// TODO - somente mover objetos que estejam na tela
// TODO - verificação de colisão (está dando sempre 1 por algum motivo)
void moveObjects(struct struct_object *obj) {
	int limit;
	if (obj->type == OBJ_MOVING_PLATFORM_LEFTRIGHT) {
		if (obj->timer < getTimer()) {
			// if linit is not defined, move 4 tiles
			if (obj->limit > 0) {
				limit = obj->limit/2;
			} else {
				limit = 4*TILE_SIZE;
			}
			if (obj->distance < limit)  {
				if (obj->direction == ANIM_RIGHT) {
					obj->position.x += 2;
					//int res = test_map_colision(p1Obj, 2, 0);
					int res = 0;
					//printf("A. moveObjects - x: 2, colision: %d\n", res);
					if (p1Obj->platform == obj && res != 1 && res != 3) {
						p1Obj->sprite->x += 2;
						checkScrolling(2, 0);
					}
				} else {
					obj->position.x -= 2;
					//int res = test_map_colision(p1Obj, -2, 0);
					int res = 0;
					//printf("B. moveObjects - x: 2, colision: %d\n", res);
					if (p1Obj->platform == obj && res != 1 && res != 3) {
						p1Obj->sprite->x -= 2;
						checkScrolling(-2, 0);
					}
				}
				obj->distance++;
				obj->timer = getTimer()+30;
			} else {
				obj->distance = 0;
				if (obj->direction == ANIM_RIGHT) {
					obj->direction = ANIM_LEFT;
				} else {
					obj->direction = ANIM_RIGHT;
				}
			}
		}
	} else if (obj->type == OBJ_MOVING_PLATFORM_UPDOWN) {
		if (obj->timer < getTimer()) {
			// for now, move 4 tiles
			if (obj->distance < 4*TILE_SIZE)  {
				if (obj->direction == ANIM_RIGHT) {
					obj->position.y += 2;
					if (p1Obj->platform == obj) {
						p1Obj->sprite->y += 2;
						checkScrolling(0, 2);
					}
				} else {
					obj->position.y -= 2;
					if (p1Obj->platform == obj) {
						p1Obj->sprite->y -= 2;
						checkScrolling(0, -2);
					}
				}
				obj->distance++;
				obj->timer = getTimer()+30;
			} else {
				obj->distance = 0;
				if (obj->direction == ANIM_RIGHT) {
					obj->direction = ANIM_LEFT;
				} else {
					obj->direction = ANIM_RIGHT;
				}
			}
		}
	} else if (obj->type == OBJ_DISAPPEARING_BLOCK) {
		if (obj->timer < getTimer()) {
			//printf(">> OBJ_DISAPPEARING_BLOCK::EXEC <<\n");
			if (obj->direction == ANIM_RIGHT) {
				obj->direction = ANIM_LEFT;
				obj->timer = getTimer() + 3000;
			} else {
				obj->direction = ANIM_RIGHT;
				obj->timer = getTimer() + 4000;
				// difference of time between blocks
				if (obj->speed > 0) {
					obj->timer += obj->speed;
					obj->speed = 0;
				}
			}
		}
	} else if (obj->type == OBJ_FALL_PLATFORM && obj->direction == ANIM_DOWN && obj->position.y < RES_H+TILE_SIZE) {
		if (obj->timer < getTimer()) {
			obj->position.y += 4;
			if (p1Obj->platform == obj) {
				p1Obj->sprite->y += 4;
				checkScrolling(0, 4);
			}
			obj->timer = getTimer() + 30;
		}
	// gravity on other types
	} else {
		int mapX = (obj->position.x+TILE_SIZE*0.5)/TILE_SIZE;
		int mapY = (obj->position.y+obj->sprite->h)/TILE_SIZE;
		//printf("Non moving item, execute gravity. x: %d, y: %d, h: %d, mapX: %d, mapY: %d, lock: %d\n", obj->position.x, obj->position.y, obj->sprite->h, mapX, mapY, map.tiles[mapX][mapY].locked);
		if (map.tiles[mapX][mapY].locked == 0 || map.tiles[mapX][mapY].locked == TERRAIN_WATER) {
			obj->position.y += 2;
		}
	}
}


void dropItem(int obj_type, int x, int y) {
	char buffer[256];
	struct struct_object *temp_obj_list = NULL;

	struct struct_object *new_obj = (struct struct_object *)malloc(sizeof(struct struct_object));
	new_obj->direction = 0;
	new_obj->distance = 0;
	sprintf(new_obj->filename, "%s", "");
	new_obj->frame = 0;
	new_obj->framesize_h = 0;
	new_obj->framesize_w = 0;
	new_obj->limit = 0;
	sprintf(new_obj->name, "%s", "");
	new_obj->position.x = 0;
	new_obj->position.y = 0;
	new_obj->speed = 0;
	new_obj->start_point.x = 0;
	new_obj->start_point.y = 0;
	new_obj->timer = 0;
	new_obj->type = -1;
	new_obj->next = NULL;

	if (obj_list == NULL) {
		printf(">> dropItem - add to the obj_list START <<\n");
		obj_list = new_obj;
	} else {
		temp_obj_list = obj_list;
		while (temp_obj_list->next) {
			temp_obj_list = temp_obj_list->next;
		}
		printf(">> dropItem - add to the obj_list END <<\n");
		temp_obj_list->next = new_obj;
	}



	if (obj_type == OBJ_ENERGY_PILL_BIG) {
		sprintf(new_obj->filename, "energy_pill_big.png");
	} else if (obj_type == OBJ_WEAPON_PILL_BIG) {
		sprintf(new_obj->filename, "weapons_pill_big.png");
	} else if (obj_type == OBJ_ENERGY_PILL_SMALL) {
		sprintf(new_obj->filename, "energy_pill_small.png");
	} else if (obj_type == OBJ_WEAPON_PILL_SMALL) {
		sprintf(new_obj->filename, "weapons_pill_small.png");
	} else {
		printf(">> dropItem - unknown item, ignoring <<");
		return;
	}
	sprintf(buffer, "%sdata/images/sprites/objects/%s", FILEPATH, new_obj->filename);
	new_obj->sprite = NULL;
	new_obj->sprite = surface_region_from_image(buffer, TILE_SIZE, TILE_SIZE);
	new_obj->position.x = x;
	new_obj->position.y = y;
	new_obj->type = obj_type;
	new_obj->framesize_w = TILE_SIZE;
	new_obj->framesize_h = TILE_SIZE;


	//printf(">> dropItem - item created, graphic: '%s', x: %d, y: %d <<\n", buffer, x, y);
}


#endif // OBJECT_H
